## fpga-icestorm 0~20151006git103e6fd

=== Makefile ===
CXX ?= clang

all:
	$(MAKE) -C icebox
	$(MAKE) -C icepack
	$(MAKE) -C iceprog
	$(MAKE) -C icemulti

clean:
	$(MAKE) -C icebox clean
	$(MAKE) -C icepack clean
	$(MAKE) -C iceprog clean
	$(MAKE) -C icemulti clean

install:
	$(MAKE) -C icebox install
	$(MAKE) -C icepack install
	$(MAKE) -C iceprog install
	$(MAKE) -C icemulti install

uninstall:
	$(MAKE) -C icebox uninstall
	$(MAKE) -C icepack uninstall
	$(MAKE) -C iceprog uninstall
	$(MAKE) -C icemulti uninstall

.PHONY: all clean install uninstall

=== icebox/Makefile ===
DESTDIR = /usr/local

all: chipdb-1k.txt chipdb-8k.txt

chipdb-1k.txt: icebox.py iceboxdb.py icebox_chipdb.py
	python3 icebox_chipdb.py > chipdb-1k.new
	mv chipdb-1k.new chipdb-1k.txt

chipdb-8k.txt: icebox.py iceboxdb.py icebox_chipdb.py
	python3 icebox_chipdb.py -8 > chipdb-8k.new
	mv chipdb-8k.new chipdb-8k.txt

clean:
	rm -f chipdb-1k.txt chipdb-8k.txt
	rm -f icebox.pyc iceboxdb.pyc

install: all
	mkdir -p $(DESTDIR)/share/icebox
	mkdir -p $(DESTDIR)/bin
	cp chipdb-1k.txt     $(DESTDIR)/share/icebox/
	cp chipdb-8k.txt     $(DESTDIR)/share/icebox/
	cp icebox.py         $(DESTDIR)/bin/icebox.py
	cp iceboxdb.py       $(DESTDIR)/bin/iceboxdb.py
	cp icebox_chipdb.py  $(DESTDIR)/bin/icebox_chipdb
	cp icebox_diff.py    $(DESTDIR)/bin/icebox_diff
	cp icebox_explain.py $(DESTDIR)/bin/icebox_explain
	cp icebox_colbuf.py  $(DESTDIR)/bin/icebox_colbuf
	cp icebox_html.py    $(DESTDIR)/bin/icebox_html
	cp icebox_maps.py    $(DESTDIR)/bin/icebox_maps
	cp icebox_vlog.py    $(DESTDIR)/bin/icebox_vlog

uninstall:
	rm -f $(DESTDIR)/bin/icebox.py
	rm -f $(DESTDIR)/bin/iceboxdb.py
	rm -f $(DESTDIR)/bin/icebox_chipdb
	rm -f $(DESTDIR)/bin/icebox_diff
	rm -f $(DESTDIR)/bin/icebox_explain
	rm -f $(DESTDIR)/bin/icebox_colbuf
	rm -f $(DESTDIR)/bin/icebox_html
	rm -f $(DESTDIR)/bin/icebox_maps
	rm -f $(DESTDIR)/bin/icebox_vlog
	rm -f $(DESTDIR)/share/icebox/chipdb-1k.txt
	rm -f $(DESTDIR)/share/icebox/chipdb-8k.txt
	-rmdir $(DESTDIR)/share/icebox

.PHONY: all clean install uninstall

=== icefuzz/Makefile ===

export LC_ALL=C

TESTS =
TESTS += binop
TESTS += pin2pin
TESTS += mesh
TESTS += fanout
TESTS += logic
TESTS += cluster
TESTS += iopack
TESTS += io
TESTS += gbio
TESTS += gbio2
TESTS += prim
TESTS += fflogic
TESTS += ram40
TESTS += pll

EIGTHK = _8k

database: bitdata_io.txt bitdata_logic.txt bitdata_ramb$(EIGTHK).txt bitdata_ramt$(EIGTHK).txt
ifeq ($(EIGTHK),_8k)
	cp cached_ramb.txt bitdata_ramb.txt
	cp cached_ramt.txt bitdata_ramt.txt
else
	cp cached_ramb_8k.txt bitdata_ramb_8k.txt
	cp cached_ramt_8k.txt bitdata_ramt_8k.txt
endif
	python3 database.py
	python3 export.py
	diff -U0 cached_io.txt bitdata_io.txt || cp -v bitdata_io.txt cached_io.txt
	diff -U0 cached_logic.txt bitdata_logic.txt || cp -v bitdata_logic.txt cached_logic.txt
	diff -U0 cached_ramb.txt bitdata_ramb.txt || cp -v bitdata_ramb.txt cached_ramb.txt
	diff -U0 cached_ramt.txt bitdata_ramt.txt || cp -v bitdata_ramt.txt cached_ramt.txt
	diff -U0 cached_ramb_8k.txt bitdata_ramb_8k.txt || cp -v bitdata_ramb_8k.txt cached_ramb_8k.txt
	diff -U0 cached_ramt_8k.txt bitdata_ramt_8k.txt || cp -v bitdata_ramt_8k.txt cached_ramt_8k.txt

timings:
ifeq ($(EIGTHK),_8k)
	cp tmedges_8k.txt tmedges.tmp
	for f in work_*/*.vsb; do echo $$f; yosys -q -f verilog -s tmedges.ys $$f; done
	sort -u tmedges.tmp > tmedges_8k.txt && rm -f tmedges.tmp
	python3 timings.py -t timings_8k.txt work_*/*.sdf > timings_8k.new
	mv timings_8k.new timings_8k.txt
else
	cp tmedges_1k.txt tmedges.tmp
	for f in work_*/*.vsb; do echo $$f; yosys -q -f verilog -s tmedges.ys $$f; done
	sort -u tmedges.tmp > tmedges_1k.txt && rm -f tmedges.tmp
	python3 timings.py -t timings_1k.txt work_*/*.sdf > timings_1k.new
	mv timings_1k.new timings_1k.txt
endif

timings_html:
	python3 timings.py -h tmedges_1k.txt -t timings_1k.txt -l "HX1K with default temp/volt settings" > timings_1k.html

data_cached.txt: cached_io.txt cached_logic.txt cached_ramb$(EIGTHK).txt cached_ramt$(EIGTHK).txt
	gawk '{ print "io", $$0; }' cached_io.txt > data_cached.new
	gawk '{ print "logic", $$0; }' cached_logic.txt >> data_cached.new
	gawk '{ print "ramb$(EIGTHK)", $$0; }' cached_ramb$(EIGTHK).txt >> data_cached.new
	gawk '{ print "ramt$(EIGTHK)", $$0; }' cached_ramt$(EIGTHK).txt >> data_cached.new
	mv data_cached.new data_cached.txt

bitdata_io.txt: data_cached.txt $(addprefix data_,$(addsuffix .txt,$(TESTS)))
	grep ^io $^ | tr -s ' ' | tr -d '\r' | cut -f2- -d' ' | sort -u > $@

bitdata_logic.txt: data_cached.txt $(addprefix data_,$(addsuffix .txt,$(TESTS)))
	grep ^logic $^ | tr -s ' ' | tr -d '\r' | cut -f2- -d' ' | sort -u > $@

bitdata_ramb$(EIGTHK).txt: data_cached.txt $(addprefix data_,$(addsuffix .txt,$(TESTS)))
	grep ^ramb$(EIGTHK) $^ | tr -s ' ' | tr -d '\r' | cut -f2- -d' ' | sort -u > $@

bitdata_ramt$(EIGTHK).txt: data_cached.txt $(addprefix data_,$(addsuffix .txt,$(TESTS)))
	grep ^ramt$(EIGTHK) $^ | tr -s ' ' | tr -d '\r' | cut -f2- -d' ' | sort -u > $@

datafiles: $(addprefix data_,$(addsuffix .txt,$(TESTS)))

../icepack/icepack:
	$(MAKE) -C ../icepack

define data_template
data_$(1).txt: make_$(1).py ../icepack/icepack
ifeq ($(EIGTHK),_8k)
	ICE8KPINS=1 python3 make_$(1).py
	+ICEDEV=hx8k-ct256 $(MAKE) -C work_$(1)
	python3 extract.py -8 work_$(1)/*.glb > $$@
else
	python3 make_$(1).py
	+$(MAKE) -C work_$(1)
	python3 extract.py work_$(1)/*.glb > $$@
endif
endef

$(foreach test,$(TESTS),$(eval $(call data_template,$(test))))

%.ok: %.bin
	bash check.sh $<

check: $(addsuffix .ok,$(basename $(wildcard work_binop/*.bin)))
check: $(addsuffix .ok,$(basename $(wildcard work_pin2pin/*.bin)))
check: $(addsuffix .ok,$(basename $(wildcard work_mesh/*.bin)))
check: $(addsuffix .ok,$(basename $(wildcard work_fanout/*.bin)))
check: $(addsuffix .ok,$(basename $(wildcard work_logic/*.bin)))
check: $(addsuffix .ok,$(basename $(wildcard work_cluster/*.bin)))
check: $(addsuffix .ok,$(basename $(wildcard work_iopack/*.bin)))
check: $(addsuffix .ok,$(basename $(wildcard work_pll/*.bin)))

clean:
	rm -rf work_*
	rm -rf data_*.txt
	rm -rf bitdata_*.txt
	rm -rf database_*.txt

.PHONY: database datafiles check clean

=== icemulti/Makefile ===
# CXX = clang
CXX ?= clang
LDLIBS = -lm -lstdc++
CXXFLAGS = -MD -O0 -ggdb -Wall -std=c++11
CC = $(CXX)
DESTDIR = /usr/local

all: icemulti

icemulti: icemulti.o

install: all
	cp icemulti $(DESTDIR)/bin/icemulti

uninstall:
	rm -f $(DESTDIR)/bin/icemulti

clean:
	rm -f icemulti
	rm -f *.o *.d

-include *.d

.PHONY: all install uninstall clean

=== icepack/Makefile ===
# CXX = clang
CXX ?= clang
LDLIBS = -lm -lstdc++
CXXFLAGS = -MD -O0 -ggdb -Wall -std=c++11 -I/usr/local/include
CC = $(CXX)
DESTDIR = /usr/local

all: icepack iceunpack

icepack: icepack.o

iceunpack: icepack
	ln -sf icepack iceunpack

install: all
	cp icepack $(DESTDIR)/bin/icepack
	ln -sf icepack $(DESTDIR)/bin/iceunpack

uninstall:
	rm -f $(DESTDIR)/bin/icepack
	rm -f $(DESTDIR)/bin/iceunpack

clean:
	rm -f icepack
	rm -f iceunpack
	rm -f *.o *.d

-include *.d

.PHONY: all install uninstall clean

=== iceprog/Makefile ===
# CC = clang
LDLIBS = -L/usr/local/lib -lftdi -lm
CFLAGS = -MD -O0 -ggdb -Wall -std=c99 -I/usr/local/include
DESTDIR = /usr/local

all: iceprog

iceprog: iceprog.o

install: all
	cp iceprog $(DESTDIR)/bin/iceprog

uninstall:
	rm -f $(DESTDIR)/bin/iceprog

clean:
	rm -f iceprog
	rm -f *.o *.d

-include *.d

.PHONY: all install uninstall clean

=== debian/changelog ===
fpga-icestorm (0~20151006git103e6fd-2) unstable; urgency=medium

  * Added udev rules so that members of the plugdev group can program
    the FPGA.
  * debian/control: Updated the Vcs-Git path so that it uses a secure protocol.

 -- Ruben Undheim <ruben.undheim@gmail.com>  Sat, 06 Feb 2016 12:34:47 +0100

fpga-icestorm (0~20151006git103e6fd-1) unstable; urgency=low

  * Initial release (Closes: #801229)

 -- Ruben Undheim <ruben.undheim@gmail.com>  Mon, 16 Nov 2015 19:57:40 +0100

=== debian/control ===
Source: fpga-icestorm
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ruben Undheim <ruben.undheim@gmail.com>
Section: electronics
Priority: optional
Build-Depends: debhelper (>= 9),
               libftdi-dev,
               python3,
               txt2man
Standards-Version: 3.9.6
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/fpga-icestorm.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/fpga-icestorm.git
Homepage: http://www.clifford.at/icestorm/

Package: fpga-icestorm-chipdb
Architecture: all
Depends: ${misc:Depends}
Description: Chip database files for fpga-icestorm
 Project IceStorm aims at documenting the bitstream format of Lattice iCE40
 FPGAs and providing simple tools for analyzing and creating bitstream files. At
 the moment the focus of the project is on the HX1K-TQ144 and HX8K-CT256
 devices, but most of the information is device-independent.
 .
 This package contains the chip database files for fpga-icestorm.
 

Package: fpga-icestorm
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         python3
Recommends: yosys
Suggests: arachne-pnr, fpga-icestorm-chipdb
Description: Tools to handle the bitstream format of Lattice iCE40 FPGAs
 Project IceStorm aims at documenting the bitstream format of Lattice iCE40
 FPGAs and providing simple tools for analyzing and creating bitstream files. At
 the moment the focus of the project is on the HX1K-TQ144 and HX8K-CT256
 devices, but most of the information is device-independent.
 .
 This package contains multiple tools needed to handle the bitstream.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

CHANGELOG_DATE ?= $(shell date -d "`dpkg-parsechangelog --show-field Date`" +"%d %B %Y")

%:
	dh $@ 

override_dh_auto_clean:
	dh_auto_clean
	$(RM) debian/man/*.1
	$(RM) -r icebox/__pycache__

override_dh_installman:
	cd debian/man ; CHANGELOG_DATE="$(CHANGELOG_DATE)" ./genmanpages.sh
	dh_installman

=== debian/watch ===
version=3
https://github.com/cliffordwolf/icestorm/releases /cliffordwolf/icestorm/archive/\w+-(\d\S+)\.tar\.(?:bz2|gz|xz)

## fpga-icestorm 0~20160218gitf2b2549

=== icemulti/Makefile ===
include ../config.mk
LDLIBS = -lm -lstdc++
CXXFLAGS = -MD -O0 -ggdb -Wall -std=c++11

all: icemulti$(EXE)

icemulti$(EXE): icemulti.o
	$(CC) -o $@ $(LDFLAGS) $^ $(LDLIBS)

install: all
	mkdir -p $(DESTDIR)$(PREFIX)/bin
	cp icemulti $(DESTDIR)$(PREFIX)/bin/icemulti

uninstall:
	rm -f $(DESTDIR)$(PREFIX)/bin/icemulti

clean:
	rm -f icemulti
	rm -f icemulti.exe
	rm -f *.o *.d

-include *.d

.PHONY: all install uninstall clean

=== icepll/Makefile ===
include ../config.mk
LDLIBS = -lm -lstdc++
CXXFLAGS = -MD -O0 -ggdb -Wall -std=c++11 -I/usr/local/include

all: icepll$(EXE)

icepll$(EXE): icepll.o
	$(CC) -o $@ $(LDFLAGS) $^ $(LDLIBS)

install: all
	mkdir -p $(DESTDIR)$(PREFIX)/bin
	cp icepll $(DESTDIR)$(PREFIX)/bin/icepll

uninstall:
	rm -f $(DESTDIR)$(PREFIX)/bin/icepll

clean:
	rm -f icepll
	rm -f icepll.exe
	rm -f *.o *.d

-include *.d

.PHONY: all install uninstall clean

=== debian/changelog ===
fpga-icestorm (0~20160218gitf2b2549-3) unstable; urgency=medium

  * debian/control:
    - Changed dependency on fpga-icestorm-chipdb from "Suggests:" to
      "Recommends:".
  * debian/patches/01_installpath.patch:
    - Fix hard-coded path to chipdb in icetime (Closes: #827176)
  * Updated all other patches such that they can be imported with gbp-pq.

 -- Ruben Undheim <ruben.undheim@gmail.com>  Tue, 14 Jun 2016 19:22:54 +0200

fpga-icestorm (0~20160218gitf2b2549-2) unstable; urgency=medium

  [ Daniel Shahaf ]
  * Fixed reproducibility (Closes: 823616) - thanks for the patch!

  [ Ruben Undheim ]
  * debian/control:
    - Updated Standards version to 3.9.8 - no changes

 -- Ruben Undheim <ruben.undheim@gmail.com>  Fri, 06 May 2016 20:45:23 +0200

fpga-icestorm (0~20160218gitf2b2549-1) unstable; urgency=medium

  [ Sebastian Kuzminsky ]
  * New upstream version
  * debian/man:
    - Added man pages for new commands: icetime and icepll
  * debian/patches:
    - Added patch override-CXX.patch so that the Debian build system decides
      which compiler to use.
    - Refreshed patches
  * debian/rules:
    - Set PREFIX=/usr in override_dh_auto_install

  [ Ruben Undheim ]
  * debian/control:
    - Updated Standards version to 3.9.7
  * Added debian/patches/fix_spelling_in_binaries.patch

 -- Ruben Undheim <ruben.undheim@gmail.com>  Thu, 25 Feb 2016 23:59:47 +0100

fpga-icestorm (0~20151006git103e6fd-3) unstable; urgency=medium

  * Set changelog date to UTC with LC_ALL=C to make man pages reproducible.

 -- Ruben Undheim <ruben.undheim@gmail.com>  Fri, 19 Feb 2016 17:46:30 +0100

## fpga-icestorm 0~20160913git266e758

=== Makefile ===
include config.mk

all:
	$(MAKE) -C icebox
	$(MAKE) -C icepack
	$(MAKE) -C iceprog
	$(MAKE) -C icemulti
	$(MAKE) -C icepll
	$(MAKE) -C icetime
	$(MAKE) -C icebram

clean:
	$(MAKE) -C icebox clean
	$(MAKE) -C icepack clean
	$(MAKE) -C iceprog clean
	$(MAKE) -C icemulti clean
	$(MAKE) -C icepll clean
	$(MAKE) -C icetime clean
	$(MAKE) -C icebram clean

install:
	$(MAKE) -C icebox install
	$(MAKE) -C icepack install
	$(MAKE) -C iceprog install
	$(MAKE) -C icemulti install
	$(MAKE) -C icepll install
	$(MAKE) -C icetime install
	$(MAKE) -C icebram install

uninstall:
	$(MAKE) -C icebox uninstall
	$(MAKE) -C icepack uninstall
	$(MAKE) -C iceprog uninstall
	$(MAKE) -C icemulti uninstall
	$(MAKE) -C icepll uninstall
	$(MAKE) -C icetime uninstall
	$(MAKE) -C icebram uninstall

mxebin: clean
	$(MAKE) MXE=1
	rm -rf icestorm-win32 && mkdir icestorm-win32
	cp icebox/chipdb-*.txt icepack/*.exe iceprog/*.exe icestorm-win32/
	cp icemulti/*.exe icepll/*.exe icetime/*.exe icestorm-win32/
	zip -r icestorm-win32.zip icestorm-win32/

.PHONY: all clean install uninstall

=== icebox/Makefile ===
include ../config.mk

all: chipdb-1k.txt chipdb-8k.txt

chipdb-1k.txt: icebox.py iceboxdb.py icebox_chipdb.py
	python3 icebox_chipdb.py > chipdb-1k.new
	mv chipdb-1k.new chipdb-1k.txt

chipdb-8k.txt: icebox.py iceboxdb.py icebox_chipdb.py
	python3 icebox_chipdb.py -8 > chipdb-8k.new
	mv chipdb-8k.new chipdb-8k.txt

clean:
	rm -f chipdb-1k.txt chipdb-8k.txt
	rm -f icebox.pyc iceboxdb.pyc

install: all
	mkdir -p $(DESTDIR)$(PREFIX)/share/icebox
	mkdir -p $(DESTDIR)$(PREFIX)/bin
	cp chipdb-1k.txt     $(DESTDIR)$(PREFIX)/share/icebox/
	cp chipdb-8k.txt     $(DESTDIR)$(PREFIX)/share/icebox/
	cp icebox.py         $(DESTDIR)$(PREFIX)/bin/icebox.py
	cp iceboxdb.py       $(DESTDIR)$(PREFIX)/bin/iceboxdb.py
	cp icebox_chipdb.py  $(DESTDIR)$(PREFIX)/bin/icebox_chipdb
	cp icebox_diff.py    $(DESTDIR)$(PREFIX)/bin/icebox_diff
	cp icebox_explain.py $(DESTDIR)$(PREFIX)/bin/icebox_explain
	cp icebox_colbuf.py  $(DESTDIR)$(PREFIX)/bin/icebox_colbuf
	cp icebox_html.py    $(DESTDIR)$(PREFIX)/bin/icebox_html
	cp icebox_maps.py    $(DESTDIR)$(PREFIX)/bin/icebox_maps
	cp icebox_vlog.py    $(DESTDIR)$(PREFIX)/bin/icebox_vlog

uninstall:
	rm -f $(DESTDIR)$(PREFIX)/bin/icebox.py
	rm -f $(DESTDIR)$(PREFIX)/bin/iceboxdb.py
	rm -f $(DESTDIR)$(PREFIX)/bin/icebox_chipdb
	rm -f $(DESTDIR)$(PREFIX)/bin/icebox_diff
	rm -f $(DESTDIR)$(PREFIX)/bin/icebox_explain
	rm -f $(DESTDIR)$(PREFIX)/bin/icebox_colbuf
	rm -f $(DESTDIR)$(PREFIX)/bin/icebox_html
	rm -f $(DESTDIR)$(PREFIX)/bin/icebox_maps
	rm -f $(DESTDIR)$(PREFIX)/bin/icebox_vlog
	rm -f $(DESTDIR)$(PREFIX)/share/icebox/chipdb-1k.txt
	rm -f $(DESTDIR)$(PREFIX)/share/icebox/chipdb-8k.txt
	-rmdir $(DESTDIR)$(PREFIX)/share/icebox

.PHONY: all clean install uninstall

=== icebram/Makefile ===
include ../config.mk
LDLIBS = -lm -lstdc++
CXXFLAGS = -MD -O0 -ggdb -Wall -std=c++11 -I/usr/local/include

ifeq ($(STATIC),1)
LDFLAGS += -static
endif

all: icebram$(EXE)

icebram$(EXE): icebram.o
	$(CC) -o $@ $(LDFLAGS) $^ $(LDLIBS)

test: icebram
	bash rundemo.sh

install: all
	mkdir -p $(DESTDIR)$(PREFIX)/bin
	cp icebram $(DESTDIR)$(PREFIX)/bin/icebram

uninstall:
	rm -f $(DESTDIR)$(PREFIX)/bin/icebram

clean:
	rm -f icebram
	rm -f icebram.exe
	rm -f demo.* demo_*.*
	rm -f *.o *.d

-include *.d

.PHONY: all test install uninstall clean

=== icefuzz/Makefile ===
--- 
+++ 
@@ -1,5 +1,6 @@
-
+include ../config.mk
 export LC_ALL=C
+export ICE_SBTIMER_LP=1
 
 TESTS =
 TESTS += binop
@@ -15,7 +16,9 @@
 TESTS += prim
 TESTS += fflogic
 TESTS += ram40
+TESTS += mem
 TESTS += pll
+TESTS += aig
 
 EIGTHK = _8k
 
@@ -38,21 +41,28 @@
 
 timings:
 ifeq ($(EIGTHK),_8k)
-	cp tmedges_8k.txt tmedges.tmp
-	for f in work_*/*.vsb; do echo $$f; yosys -q -f verilog -s tmedges.ys $$f; done
-	sort -u tmedges.tmp > tmedges_8k.txt && rm -f tmedges.tmp
-	python3 timings.py -t timings_8k.txt work_*/*.sdf > timings_8k.new
-	mv timings_8k.new timings_8k.txt
+	cp tmedges.txt tmedges.tmp
+	set -e; for f in work_*/*.vsb; do echo $$f; yosys -q -f verilog -s tmedges.ys $$f; done
+	sort -u tmedges.tmp > tmedges.txt && rm -f tmedges.tmp
+	python3 timings.py -t timings_hx8k.txt work_*/*.sdf > timings_hx8k.new
+	mv timings_hx8k.new timings_hx8k.txt
+	python3 timings.py -t timings_lp8k.txt work_*/*.slp > timings_lp8k.new
+	mv timings_lp8k.new timings_lp8k.txt
 else
-	cp tmedges_1k.txt tmedges.tmp
-	for f in work_*/*.vsb; do echo $$f; yosys -q -f verilog -s tmedges.ys $$f; done
-	sort -u tmedges.tmp > tmedges_1k.txt && rm -f tmedges.tmp
-	python3 timings.py -t timings_1k.txt work_*/*.sdf > timings_1k.new
-	mv timings_1k.new timings_1k.txt
+	cp tmedges.txt tmedges.tmp
+	set -e; for f in work_*/*.vsb; do echo $$f; yosys -q -f verilog -s tmedges.ys $$f; done
+	sort -u tmedges.tmp > tmedges.txt && rm -f tmedges.tmp
+	python3 timings.py -t timings_hx1k.txt work_*/*.sdf > timings_hx1k.new
+	mv timings_hx1k.new timings_hx1k.txt
+	python3 timings.py -t timings_lp1k.txt work_*/*.slp > timings_lp1k.new
+	mv timings_lp1k.new timings_lp1k.txt
 endif
 
 timings_html:
-	python3 timings.py -h tmedges_1k.txt -t timings_1k.txt -l "HX1K with default temp/volt settings" > timings_1k.html
+	python3 timings.py -h tmedges.txt -t timings_hx1k.txt -l "HX1K with default temp/volt settings" > timings_hx1k.html
+	python3 timings.py -h tmedges.txt -t timings_hx8k.txt -l "HX8K with default temp/volt settings" > timings_hx8k.html
+	python3 timings.py -h tmedges.txt -t timings_lp1k.txt -l "LP1K with default temp/volt settings" > timings_lp1k.html
+	python3 timings.py -h tmedges.txt -t timings_lp8k.txt -l "LP8K with default temp/volt settings" > timings_lp8k.html
 
 data_cached.txt: cached_io.txt cached_logic.txt cached_ramb$(EIGTHK).txt cached_ramt$(EIGTHK).txt
 	gawk '{ print "io", $$0; }' cached_io.txt > data_cached.new
@@ -110,6 +120,7 @@
 	rm -rf data_*.txt
 	rm -rf bitdata_*.txt
 	rm -rf database_*.txt
+	rm -rf timings_*.html
 
 .PHONY: database datafiles check clean

=== icemulti/Makefile ===
--- 
+++ 
@@ -1,6 +1,10 @@
 include ../config.mk
 LDLIBS = -lm -lstdc++
 CXXFLAGS = -MD -O0 -ggdb -Wall -std=c++11
+
+ifeq ($(STATIC),1)
+LDFLAGS += -static
+endif
 
 all: icemulti$(EXE)

=== icepack/Makefile ===
include ../config.mk
LDLIBS = -lm -lstdc++
CXXFLAGS = -MD -O0 -ggdb -Wall -std=c++11 -I/usr/local/include
MXEGCC = /usr/local/src/mxe/usr/bin/i686-pc-mingw32-gcc

ifeq ($(STATIC),1)
LDFLAGS += -static
endif

all: icepack$(EXE) iceunpack$(EXE)

icepack$(EXE): icepack.o
	$(CC) -o $@ $(LDFLAGS) $^ $(LDLIBS)

iceunpack: icepack
	ln -sf icepack iceunpack

iceunpack.exe:
	# no iceunpack.exe, use icepack -u

install: all
	mkdir -p $(DESTDIR)$(PREFIX)/bin
	cp icepack $(DESTDIR)$(PREFIX)/bin/icepack
	ln -sf icepack $(DESTDIR)$(PREFIX)/bin/iceunpack

uninstall:
	rm -f $(DESTDIR)$(PREFIX)/bin/icepack
	rm -f $(DESTDIR)$(PREFIX)/bin/iceunpack

clean:
	rm -f icepack
	rm -f iceunpack
	rm -f icepack.exe
	rm -f *.o *.d

-include *.d

.PHONY: all install uninstall clean

=== icepll/Makefile ===
--- 
+++ 
@@ -1,6 +1,10 @@
 include ../config.mk
 LDLIBS = -lm -lstdc++
 CXXFLAGS = -MD -O0 -ggdb -Wall -std=c++11 -I/usr/local/include
+
+ifeq ($(STATIC),1)
+LDFLAGS += -static
+endif
 
 all: icepll$(EXE)

=== iceprog/Makefile ===
include ../config.mk

ifneq ($(shell uname -s),Darwin)
  LDLIBS = -L/usr/local/lib -lm
  CFLAGS = -MD -O0 -ggdb -Wall -std=c99 -I/usr/local/include
else
  LIBFTDI_NAME = $(shell $(PKG_CONFIG) --exists libftdi1 && echo ftdi1 || echo ftdi)
  LDLIBS = -L/usr/local/lib -l$(LIBFTDI_NAME) -lm
  CFLAGS = -MD -O0 -ggdb -Wall -std=c99 -I/usr/local/include
endif

ifeq ($(STATIC),1)
LDFLAGS += -static
LDLIBS += $(shell for pkg in libftdi1 libftdi; do $(PKG_CONFIG) --silence-errors --static --libs $$pkg && exit; done; echo -lftdi; )
CFLAGS += $(shell for pkg in libftdi1 libftdi; do $(PKG_CONFIG) --silence-errors --static --cflags $$pkg && exit; done; )
else
LDLIBS += $(shell for pkg in libftdi1 libftdi; do $(PKG_CONFIG) --silence-errors --libs $$pkg && exit; done; echo -lftdi; )
CFLAGS += $(shell for pkg in libftdi1 libftdi; do $(PKG_CONFIG) --silence-errors --cflags $$pkg && exit; done; )
endif

all: iceprog$(EXE)

iceprog$(EXE): iceprog.o
	$(CC) -o $@ $(LDFLAGS) $^ $(LDLIBS)

install: all
	mkdir -p $(DESTDIR)$(PREFIX)/bin
	cp iceprog $(DESTDIR)$(PREFIX)/bin/iceprog

uninstall:
	rm -f $(DESTDIR)$(PREFIX)/bin/iceprog

clean:
	rm -f iceprog
	rm -f iceprog.exe
	rm -f *.o *.d

-include *.d

.PHONY: all install uninstall clean

=== icetime/Makefile ===
include ../config.mk
LDLIBS = -lm -lstdc++
CXXFLAGS = -MD -O0 -ggdb -Wall -std=c++11 -I/usr/local/include -DPREFIX='"$(PREFIX)"'

ifeq ($(STATIC),1)
LDFLAGS += -static
endif

all: icetime$(EXE)

icetime$(EXE): icetime.o
	$(CC) -o $@ $(LDFLAGS) $^ $(LDLIBS)

icetime.o: icetime.cc timings.inc

timings.inc: timings.py ../icefuzz/timings_*.txt
	python3 timings.py > timings.inc.new
	mv timings.inc.new timings.inc

install: all
	mkdir -p $(DESTDIR)$(PREFIX)/bin
	cp icetime $(DESTDIR)$(PREFIX)/bin/icetime

uninstall:
	rm -f $(DESTDIR)$(PREFIX)/bin/icetime


# View timing netlist:
#  yosys -qp 'read_verilog -lib cells.v; prep; show' test0_ref.v
#  yosys -qp 'read_verilog -lib cells.v; prep; show' test0_out.v

test0 test1 test2 test3 test4 test5 test6 test7 test8 test9: icetime
	test -f $@_ref.v || python3 mktest.py $@
	./icetime -m -d hx1k -P tq144 -p $@.pcf -o $@_out.v $@.asc
	yosys $@.ys

run0 run1 run2 run3 run4 run5 run6 run7 run8 run9: icetime
	./icetime -t -d hx1k -P tq144 -p $(subst run,test,$@).pcf $(subst run,test,$@).asc

show0 show1 show2 show3 show4 show5 show6 show7 show8 show9: icetime
	bash show.sh $(subst show,test,$@)
	xdot $(subst show,test,$@).dot

test: test0 test1 test2 test3 test4 test5 test6 test7 test8 test9

show: show0 show1 show2 show3 show4 show5 show6 show7 show8 show9

clean:
	rm -f icetime icetime.exe timings.inc *.o *.d
	rm -rf test[0-9]*

-include *.d

.PHONY: all install uninstall clean

=== examples/hx8kboard/Makefile ===
PROJ = example
PIN_DEF = hx8kboard.pcf
DEVICE = hx8k

all: $(PROJ).rpt $(PROJ).bin

%.blif: %.v
	yosys -p 'synth_ice40 -top top -blif $@' $<

%.asc: $(PIN_DEF) %.blif
	arachne-pnr -d $(subst hx,,$(subst lp,,$(DEVICE))) -o $@ -p $^

%.bin: %.asc
	icepack $< $@

%.rpt: %.asc
	icetime -d $(DEVICE) -mtr $@ $<

prog: $(PROJ).bin
	iceprog $<

sudo-prog: $(PROJ).bin
	@echo 'Executing prog as root!!!'
	sudo iceprog $<

clean:
	rm -f $(PROJ).blif $(PROJ).asc $(PROJ).rpt $(PROJ).bin

.SECONDARY:
.PHONY: all prog clean

=== examples/iceblink/Makefile ===
PROJ = example
PIN_DEF = iceblink.pcf
DEVICE = hx1k

all: $(PROJ).rpt $(PROJ).bin

%.blif: %.v
	yosys -p 'synth_ice40 -top top -blif $@' $<

%.asc: $(PIN_DEF) %.blif
	arachne-pnr -d $(subst hx,,$(subst lp,,$(DEVICE))) -o $@ -p $^ -P vq100

%.bin: %.asc
	icepack $< $@

%.rpt: %.asc
	icetime -d $(DEVICE) -mtr $@ $<

prog: $(PROJ).bin
	iCEburn.py  -e -v -w  $<

sudo-prog: $(PROJ).bin
	@echo 'Executing prog as root!!!'
	iCEburn.py  -e -v -w  $<

clean:
	rm -f $(PROJ).blif $(PROJ).asc $(PROJ).bin

.PHONY: all prog clean

=== examples/icestick/Makefile ===
PROJ = example
PIN_DEF = icestick.pcf
DEVICE = hx1k

all: $(PROJ).rpt $(PROJ).bin

%.blif: %.v
	yosys -p 'synth_ice40 -top top -blif $@' $<

%.asc: $(PIN_DEF) %.blif
	arachne-pnr -d $(subst hx,,$(subst lp,,$(DEVICE))) -o $@ -p $^

%.bin: %.asc
	icepack $< $@

%.rpt: %.asc
	icetime -d $(DEVICE) -mtr $@ $<

prog: $(PROJ).bin
	iceprog $<

sudo-prog: $(PROJ).bin
	@echo 'Executing prog as root!!!'
	sudo iceprog $<

clean:
	rm -f $(PROJ).blif $(PROJ).asc $(PROJ).rpt $(PROJ).bin

.SECONDARY:
.PHONY: all prog clean

=== debian/changelog ===
fpga-icestorm (0~20160913git266e758-3) unstable; urgency=medium

  * Addded 'Tag+="uaccess"' to udev rule. Thanks Petter! (Closes: #840380)

 -- Ruben Undheim <ruben.undheim@gmail.com>  Tue, 08 Nov 2016 22:45:14 +0100

fpga-icestorm (0~20160913git266e758-2) unstable; urgency=medium

  * debian/patches/0004-Make-the-build-reproducible.patch
    - Another patch for reproducibility from Chris Lamb. Thanks!
      (Closes: #840098)

 -- Ruben Undheim <ruben.undheim@gmail.com>  Sun, 09 Oct 2016 00:59:44 +0200

fpga-icestorm (0~20160913git266e758-1) unstable; urgency=low

  * New upstream version
  * debian/man/icebram.txt:
    - New man page for new command
  * debian/patches/03_cxxflags.patch
    - Also do this for the new command

 -- Ruben Undheim <ruben.undheim@gmail.com>  Sun, 18 Sep 2016 12:21:07 +0200

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
                libftdi-dev,
                python3,
                txt2man
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/fpga-icestorm.git
 Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/fpga-icestorm.git
 Homepage: http://www.clifford.at/icestorm/
@@ -29,8 +29,8 @@
 Depends: ${shlibs:Depends},
          ${misc:Depends},
          python3
-Recommends: yosys
-Suggests: arachne-pnr, fpga-icestorm-chipdb
+Recommends: yosys, fpga-icestorm-chipdb
+Suggests: arachne-pnr
 Description: Tools to handle the bitstream format of Lattice iCE40 FPGAs
  Project IceStorm aims at documenting the bitstream format of Lattice iCE40
  FPGAs and providing simple tools for analyzing and creating bitstream files. At

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

CHANGELOG_DATE ?= $(shell LC_ALL=C date -u -d "`dpkg-parsechangelog --show-field Date`" +"%d %B %Y")

%:
	dh $@ 

override_dh_auto_clean:
	dh_auto_clean
	$(RM) debian/man/*.1
	$(RM) -r icebox/__pycache__

override_dh_auto_install:
	PREFIX=/usr dh_auto_install

override_dh_installman:
	cd debian/man ; CHANGELOG_DATE="$(CHANGELOG_DATE)" ./genmanpages.sh
	dh_installman

## fpga-icestorm 0~20180809git7e73288

=== debian/changelog ===
fpga-icestorm (0~20180809git7e73288-1) unstable; urgency=medium

  * New upstream GIT HEAD
  * debian/compat: level 11
  * debian/control:
    - Change Maintainer to
        Debian Electronics Team <pkg-electronics-devel@lists.alioth.debian.org>
    - debhelper >= 11
    - New standards version 4.2.0 - no changes
    - "pkg-config" added as build-dependency
  * debian/tests/control and debian/tests/can-show-help:
    - Added simple autopkgtest to verify that "iceprog" can be started
      with the help command.
  * debian/upstream/metadata added
  * debian/watch:
    - Update to use git directly since upstream does not currently make regular
      releases

 -- Ruben Undheim <ruben.undheim@gmail.com>  Fri, 17 Aug 2018 13:47:54 +0200

fpga-icestorm (0~20180710git6a1bd78-1) unstable; urgency=low

  * New upstream version - refreshed patches
  * debian/control:
    - New standards version: 4.1.5 - no changes
    - fpga-icestorm-chipdb marked "Multi-Arch: foreign"
    - VCS URLs set to salsa.debian.org
  * debian/at.clifford.icestorm.metainfo.xml:
    - AppStream info for the USB connected device
  * debian/copyright: updates matching new upstream version
  * debian/rules:
    - dpkg-parsechangelog replaced with /usr/share/dpkg/pkg-info.mk

 -- Ruben Undheim <ruben.undheim@gmail.com>  Fri, 13 Jul 2018 23:36:31 +0200

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,21 @@
 Source: fpga-icestorm
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Electronics Team <pkg-electronics-devel@lists.alioth.debian.org>
 Uploaders: Ruben Undheim <ruben.undheim@gmail.com>
 Section: electronics
 Priority: optional
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper (>= 11),
                libftdi-dev,
                python3,
-               txt2man
-Standards-Version: 3.9.8
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/fpga-icestorm.git
-Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/fpga-icestorm.git
+               txt2man,
+               pkg-config
+Standards-Version: 4.2.0
+Vcs-Browser: https://salsa.debian.org/electronics-team/fpga-icestorm
+Vcs-Git: https://salsa.debian.org/electronics-team/fpga-icestorm.git
 Homepage: http://www.clifford.at/icestorm/
 
 Package: fpga-icestorm-chipdb
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}
 Description: Chip database files for fpga-icestorm
  Project IceStorm aims at documenting the bitstream format of Lattice iCE40
@@ -22,7 +24,6 @@
  devices, but most of the information is device-independent.
  .
  This package contains the chip database files for fpga-icestorm.
- 
 
 Package: fpga-icestorm
 Architecture: any

## fpga-icestorm 0~20180904git8f61acd

=== icetime/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 include ../config.mk
 LDLIBS = -lm -lstdc++
-CXXFLAGS = -MD -O0 -ggdb -Wall -std=c++11 -I/usr/local/include -DPREFIX='"$(PREFIX)"'
+override CXXFLAGS += -DPREFIX='"$(PREFIX)"' -DCHIPDB_SUBDIR='"$(CHIPDB_SUBDIR)"'
 
 ifeq ($(STATIC),1)
 LDFLAGS += -static
@@ -8,8 +8,26 @@
 
 all: icetime$(EXE)
 
+ifeq ($(EXE),.js)
+icetime$(EXE): | share/$(CHIPDB_SUBDIR)/chipdb-384.txt share/$(CHIPDB_SUBDIR)/chipdb-1k.txt share/$(CHIPDB_SUBDIR)/chipdb-8k.txt share/$(CHIPDB_SUBDIR)/chipdb-5k.txt
+
+share/$(CHIPDB_SUBDIR)/chipdb-384.txt: ../icebox/chipdb-384.txt
+	mkdir -p share/$(CHIPDB_SUBDIR)
+	cp $< $@
+share/$(CHIPDB_SUBDIR)/chipdb-1k.txt: ../icebox/chipdb-1k.txt
+	mkdir -p share/$(CHIPDB_SUBDIR)
+	cp $< $@
+share/$(CHIPDB_SUBDIR)/chipdb-8k.txt: ../icebox/chipdb-8k.txt
+	mkdir -p share/$(CHIPDB_SUBDIR)
+	cp $< $@
+share/$(CHIPDB_SUBDIR)/chipdb-5k.txt: ../icebox/chipdb-5k.txt
+	mkdir -p share/$(CHIPDB_SUBDIR)
+	cp $< $@
+override LDFLAGS += --embed-file share
+endif
+
 icetime$(EXE): icetime.o
-	$(CC) -o $@ $(LDFLAGS) $^ $(LDLIBS)
+	$(CXX) -o $@ $(LDFLAGS) $^ $(LDLIBS)
 
 icetime.o: icetime.cc timings.inc
 
@@ -19,10 +37,12 @@
 
 install: all
 	mkdir -p $(DESTDIR)$(PREFIX)/bin
-	cp icetime $(DESTDIR)$(PREFIX)/bin/icetime
+	mkdir -p $(DESTDIR)$(PREFIX)/share/icebox
+	cp icetime$(EXE) $(DESTDIR)$(PREFIX)/bin/icetime$(EXE)
+	cp ../icefuzz/timings_*.txt $(DESTDIR)$(PREFIX)/share/icebox/
 
 uninstall:
-	rm -f $(DESTDIR)$(PREFIX)/bin/icetime
+	rm -f $(DESTDIR)$(PREFIX)/bin/icetime$(EXE)
 
 
 # View timing netlist:
@@ -46,7 +66,7 @@
 show: show0 show1 show2 show3 show4 show5 show6 show7 show8 show9
 
 clean:
-	rm -f icetime icetime.exe timings.inc *.o *.d
+	rm -f icetime$(EXE) icetime.exe timings.inc *.o *.d
 	rm -rf test[0-9]*
 
 -include *.d

=== debian/changelog ===
fpga-icestorm (0~20180904git8f61acd-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports

 -- Ruben Undheim <ruben.undheim@gmail.com>  Wed, 31 Oct 2018 23:29:27 +0100

fpga-icestorm (0~20180904git8f61acd-1) unstable; urgency=medium

  * New upstream GIT HEAD
  * debian/copyright:
    - Added new copyright holder

 -- Ruben Undheim <ruben.undheim@gmail.com>  Fri, 07 Sep 2018 22:20:22 +0000

fpga-icestorm (0~20180809git7e73288-2) unstable; urgency=medium

  * d/patches/0003-Install-timing-data-also-in-fpga-icestorm-chipdb.patch:
    - Also install timing data from icetime into
      /usr/share/fpga-icestorm/chipdb
  * debian/control:
    - New standards version 4.2.1 - no changes

 -- Ruben Undheim <ruben.undheim@gmail.com>  Thu, 06 Sep 2018 21:47:27 +0200

## fpga-icestorm 0~20181109git9671b76

=== Makefile ===
SUBDIRS = icebox icepack iceprog icemulti icepll icetime icebram

include config.mk

all: $(addsuffix .all,$(SUBDIRS))
$(addsuffix .all,$(SUBDIRS)):
	$(MAKE) -C $(basename $@) all

clean install uninstall:
	for dir in $(SUBDIRS); do \
		$(MAKE) -C $$dir $@ || exit; \
	done

mxebin: clean
	$(MAKE) MXE=1
	rm -rf icestorm-win32 && mkdir icestorm-win32
	cp icebox/chipdb-*.txt icepack/*.exe iceprog/*.exe icestorm-win32/
	cp icemulti/*.exe icepll/*.exe icetime/*.exe icestorm-win32/
	zip -r icestorm-win32.zip icestorm-win32/

.PHONY: all clean install uninstall

=== icebox/Makefile ===
include ../config.mk

all: chipdb-384.txt chipdb-1k.txt chipdb-8k.txt chipdb-5k.txt chipdb-lm4k.txt

chipdb-384.txt: icebox.py iceboxdb.py icebox_chipdb.py
	python3 icebox_chipdb.py -3 > chipdb-384.new
	mv chipdb-384.new chipdb-384.txt

chipdb-1k.txt: icebox.py iceboxdb.py icebox_chipdb.py
	python3 icebox_chipdb.py > chipdb-1k.new
	mv chipdb-1k.new chipdb-1k.txt

chipdb-5k.txt: icebox.py iceboxdb.py icebox_chipdb.py
	python3 icebox_chipdb.py -5 > chipdb-5k.new
	mv chipdb-5k.new chipdb-5k.txt

chipdb-lm4k.txt: icebox.py iceboxdb.py icebox_chipdb.py
	python3 icebox_chipdb.py -4 > chipdb-lm4k.new
	mv chipdb-lm4k.new chipdb-lm4k.txt

chipdb-8k.txt: icebox.py iceboxdb.py icebox_chipdb.py
	python3 icebox_chipdb.py -8 > chipdb-8k.new
	mv chipdb-8k.new chipdb-8k.txt

check: all
	python3 tc_xlat_netnames.py
	python3 tc_rxlat_netnames.py
	python3 tc_logic_xpr.py

clean:
	rm -f chipdb-1k.txt chipdb-8k.txt chipdb-384.txt chipdb-5k.txt chipdb-lm4k.txt
	rm -f icebox.pyc iceboxdb.pyc

install: all
	mkdir -p $(DESTDIR)$(PREFIX)/share/icebox
	mkdir -p $(DESTDIR)$(PREFIX)/bin
	cp chipdb-384.txt    $(DESTDIR)$(PREFIX)/share/icebox/
	cp chipdb-1k.txt     $(DESTDIR)$(PREFIX)/share/icebox/
	cp chipdb-8k.txt     $(DESTDIR)$(PREFIX)/share/icebox/
	cp chipdb-5k.txt     $(DESTDIR)$(PREFIX)/share/icebox/
	cp chipdb-lm4k.txt   $(DESTDIR)$(PREFIX)/share/icebox/
	cp icebox.py         $(DESTDIR)$(PREFIX)/bin/icebox.py
	cp iceboxdb.py       $(DESTDIR)$(PREFIX)/bin/iceboxdb.py
	cp icebox_chipdb.py  $(DESTDIR)$(PREFIX)/bin/icebox_chipdb$(PY_EXE)
	cp icebox_diff.py    $(DESTDIR)$(PREFIX)/bin/icebox_diff$(PY_EXE)
	cp icebox_explain.py $(DESTDIR)$(PREFIX)/bin/icebox_explain$(PY_EXE)
	cp icebox_asc2hlc.py $(DESTDIR)$(PREFIX)/bin/icebox_asc2hlc$(PY_EXE)
	cp icebox_hlc2asc.py $(DESTDIR)$(PREFIX)/bin/icebox_hlc2asc$(PY_EXE)
	cp icebox_colbuf.py  $(DESTDIR)$(PREFIX)/bin/icebox_colbuf$(PY_EXE)
	cp icebox_html.py    $(DESTDIR)$(PREFIX)/bin/icebox_html$(PY_EXE)
	cp icebox_maps.py    $(DESTDIR)$(PREFIX)/bin/icebox_maps$(PY_EXE)
	cp icebox_vlog.py    $(DESTDIR)$(PREFIX)/bin/icebox_vlog$(PY_EXE)
	cp icebox_stat.py    $(DESTDIR)$(PREFIX)/bin/icebox_stat$(PY_EXE)

uninstall:
	rm -f $(DESTDIR)$(PREFIX)/bin/icebox.py
	rm -f $(DESTDIR)$(PREFIX)/bin/iceboxdb.py
	rm -f $(DESTDIR)$(PREFIX)/bin/icebox_chipdb$(PY_EXE)
	rm -f $(DESTDIR)$(PREFIX)/bin/icebox_diff$(PY_EXE)
	rm -f $(DESTDIR)$(PREFIX)/bin/icebox_explain$(PY_EXE)
	rm -f $(DESTDIR)$(PREFIX)/bin/icebox_asc2hlc$(PY_EXE)
	rm -f $(DESTDIR)$(PREFIX)/bin/icebox_hlc2asc$(PY_EXE)
	rm -f $(DESTDIR)$(PREFIX)/bin/icebox_colbuf$(PY_EXE)
	rm -f $(DESTDIR)$(PREFIX)/bin/icebox_html$(PY_EXE)
	rm -f $(DESTDIR)$(PREFIX)/bin/icebox_maps$(PY_EXE)
	rm -f $(DESTDIR)$(PREFIX)/bin/icebox_vlog$(PY_EXE)
	rm -f $(DESTDIR)$(PREFIX)/bin/icebox_stat$(PY_EXE)
	rm -f $(DESTDIR)$(PREFIX)/share/icebox/chipdb-384.txt
	rm -f $(DESTDIR)$(PREFIX)/share/icebox/chipdb-1k.txt
	rm -f $(DESTDIR)$(PREFIX)/share/icebox/chipdb-8k.txt
	rm -f $(DESTDIR)$(PREFIX)/share/icebox/chipdb-lm4k.txt
	-rmdir $(DESTDIR)$(PREFIX)/share/icebox

.PHONY: all check clean install uninstall

=== icebram/Makefile ===
include ../config.mk

ifeq ($(STATIC),1)
LDFLAGS += -static
endif

all: icebram$(EXE)

icebram$(EXE): icebram.o
	$(CXX) -o $@ $(LDFLAGS) $^ $(LDLIBS)

test: icebram
	bash rundemo.sh

install: all
	mkdir -p $(DESTDIR)$(PREFIX)/bin
	cp icebram$(EXE) $(DESTDIR)$(PREFIX)/bin/icebram$(EXE)

uninstall:
	rm -f $(DESTDIR)$(PREFIX)/bin/icebram$(EXE)

clean:
	rm -f icebram$(EXE)
	rm -f icebram.exe
	rm -f demo.* demo_*.*
	rm -f *.o *.d

-include *.d

.PHONY: all test install uninstall clean

=== icefuzz/Makefile ===
include ../config.mk
export LC_ALL=C
export ICE_SBTIMER_LP=1

DEVICECLASS = 1k

ifeq ($(DEVICECLASS), 384)
  DEVICE := lp384-cm49
	THREEH = _384
endif

ifeq ($(DEVICECLASS), 1k)
	DEVICE := hx1k-tq144
endif

ifeq ($(DEVICECLASS), 5k)
	DEVICE := up5k-sg48
	RAM_SUFFIX := _8k
endif

ifeq ($(DEVICECLASS), 4k)
	DEVICE := lm4k-cm49
	RAM_SUFFIX := _8k
endif

ifeq ($(DEVICECLASS), 8k)
  DEVICE := hx8k-ct256
  RAM_SUFFIX = _8k
endif

TESTS =
TESTS += binop
TESTS += pin2pin
TESTS += mesh
TESTS += fanout
TESTS += logic
TESTS += cluster
TESTS += iopack
TESTS += io
TESTS += gbio
TESTS += gbio2
TESTS += prim
TESTS += fflogic
ifneq ($(DEVICECLASS),384)
 TESTS += ram40
 TESTS += mem
 TESTS += pll
 TESTS += aig
endif
ifeq ($(DEVICECLASS),5k)
 TESTS += dsp
 TESTS += upip
endif
database: bitdata_io.txt bitdata_logic.txt bitdata_ramb$(RAM_SUFFIX).txt bitdata_ramt$(RAM_SUFFIX).txt bitdata_dsp0_5k.txt bitdata_dsp1_5k.txt bitdata_dsp2_5k.txt bitdata_dsp3_5k.txt bitdata_ipcon_5k.txt
ifneq ($(RAM_SUFFIX),)
	cp cached_ramb.txt bitdata_ramb.txt
	cp cached_ramt.txt bitdata_ramt.txt
endif
ifneq ($(RAM_SUFFIX),_8k)
	cp cached_ramb_8k.txt bitdata_ramb_8k.txt
	cp cached_ramt_8k.txt bitdata_ramt_8k.txt
endif
ifneq ($(RAM_SUFFIX),_5k)
	cp cached_dsp0_5k.txt bitdata_dsp0_5k.txt
	cp cached_dsp1_5k.txt bitdata_dsp1_5k.txt
	cp cached_dsp2_5k.txt bitdata_dsp2_5k.txt
	cp cached_dsp3_5k.txt bitdata_dsp3_5k.txt
	cp cached_ipcon_5k.txt bitdata_ipcon_5k.txt
endif
	ICEDEVICE=$(DEVICECLASS) python3 database.py
	python3 export.py
	diff -U0 cached_io.txt bitdata_io.txt || cp -v bitdata_io.txt cached_io.txt
	diff -U0 cached_logic.txt bitdata_logic.txt || cp -v bitdata_logic.txt cached_logic.txt
	diff -U0 cached_ramb$(RAM_SUFFIX).txt bitdata_ramb$(RAM_SUFFIX).txt || cp -v bitdata_ramb$(RAM_SUFFIX).txt cached_ramb$(RAM_SUFFIX).txt
	diff -U0 cached_ramt$(RAM_SUFFIX).txt bitdata_ramt$(RAM_SUFFIX).txt || cp -v bitdata_ramt$(RAM_SUFFIX).txt cached_ramt$(RAM_SUFFIX).txt
	diff -U0 cached_dsp0_5k.txt bitdata_dsp0_5k.txt || cp -v bitdata_dsp0_5k.txt cached_dsp0_5k.txt
	diff -U0 cached_dsp1_5k.txt bitdata_dsp1_5k.txt || cp -v bitdata_dsp1_5k.txt cached_dsp1_5k.txt
	diff -U0 cached_dsp2_5k.txt bitdata_dsp2_5k.txt || cp -v bitdata_dsp2_5k.txt cached_dsp2_5k.txt
	diff -U0 cached_dsp3_5k.txt bitdata_dsp3_5k.txt || cp -v bitdata_dsp3_5k.txt cached_dsp3_5k.txt
	diff -U0 cached_ipcon_5k.txt bitdata_ipcon_5k.txt || cp -v bitdata_ipcon_5k.txt cached_ipcon_5k.txt

timings:
ifeq ($(DEVICECLASS),5k)
	cp tmedges.txt tmedges.tmp
	set -e; for f in work_$(DEVICECLASS)_*/*.vsb; do echo $$f; sed '/defparam/d' < $$f > $$f.fixed;  yosys -q -f verilog -s tmedges.ys $$f.fixed; python3 rename_dsps.py $$f; done
	sort -u tmedges.tmp > tmedges.txt && rm -f tmedges.tmp
	python3 timings.py -t timings_up5k.txt work_*/*.sdf > timings_up5k.new
	mv timings_up5k.new timings_up5k.txt
else
ifeq ($(DEVICECLASS),8k)
	cp tmedges.txt tmedges.tmp
	set -e; for f in work_$(DEVICECLASS)_*/*.vsb; do echo $$f; yosys -q -f verilog -s tmedges.ys $$f; done
	sort -u tmedges.tmp > tmedges.txt && rm -f tmedges.tmp
	python3 timings.py -t timings_hx8k.txt work_*/*.sdf > timings_hx8k.new
	mv timings_hx8k.new timings_hx8k.txt
	python3 timings.py -t timings_lp8k.txt work_*/*.slp > timings_lp8k.new
	mv timings_lp8k.new timings_lp8k.txt
else
 ifeq ($(DEVICECLASS),384)
	cp tmedges.txt tmedges.tmp
	set -e; for f in work_$(DEVICECLASS)_*/*.vsb; do echo $$f; yosys -q -f verilog -s tmedges.ys $$f; done
	sort -u tmedges.tmp > tmedges.txt && rm -f tmedges.tmp
	python3 timings.py -t timings_lp384.txt work_*/*.slp > timings_lp384.new
	mv timings_lp384.new timings_lp384.txt
 else
	cp tmedges.txt tmedges.tmp
	set -e; for f in work_$(DEVICECLASS)_*/*.vsb; do echo $$f; yosys -q -f verilog -s tmedges.ys $$f; done
	sort -u tmedges.tmp > tmedges.txt && rm -f tmedges.tmp
	python3 timings.py -t timings_hx1k.txt work_*/*.sdf > timings_hx1k.new
	mv timings_hx1k.new timings_hx1k.txt
	python3 timings.py -t timings_lp1k.txt work_*/*.slp > timings_lp1k.new
	mv timings_lp1k.new timings_lp1k.txt
 endif
endif
endif
timings_html:
	python3 timings.py -h tmedges.txt -t timings_hx1k.txt -l "HX1K with default temp/volt settings" > timings_hx1k.html
	python3 timings.py -h tmedges.txt -t timings_hx8k.txt -l "HX8K with default temp/volt settings" > timings_hx8k.html
	python3 timings.py -h tmedges.txt -t timings_lp1k.txt -l "LP1K with default temp/volt settings" > timings_lp1k.html
	python3 timings.py -h tmedges.txt -t timings_lp8k.txt -l "LP8K with default temp/volt settings" > timings_lp8k.html
	python3 timings.py -h tmedges.txt -t timings_lp384.txt -l "LP384 with default temp/volt settings" > timings_lp384.html
	python3 timings.py -h tmedges.txt -t timings_up5k.txt -l "UP5K with default temp/volt settings" > timings_up5k.html
data_cached.txt: cached_io.txt cached_logic.txt cached_ramb$(RAM_SUFFIX).txt cached_ramt$(RAM_SUFFIX).txt cached_dsp0_5k.txt cached_dsp1_5k.txt cached_dsp2_5k.txt cached_dsp3_5k.txt cached_ipcon_5k.txt 
	gawk '{ print "io", $$0; }' cached_io.txt > data_cached.new
	gawk '{ print "logic", $$0; }' cached_logic.txt >> data_cached.new
	gawk '{ print "ramb$(RAM_SUFFIX)", $$0; }' cached_ramb$(RAM_SUFFIX).txt >> data_cached.new
	gawk '{ print "ramt$(RAM_SUFFIX)", $$0; }' cached_ramt$(RAM_SUFFIX).txt >> data_cached.new
	
	gawk '{ print "dsp0_5k", $$0; }' cached_dsp0_5k.txt >> data_cached.new
	gawk '{ print "dsp1_5k", $$0; }' cached_dsp1_5k.txt >> data_cached.new
	gawk '{ print "dsp2_5k", $$0; }' cached_dsp2_5k.txt >> data_cached.new
	gawk '{ print "dsp3_5k", $$0; }' cached_dsp3_5k.txt >> data_cached.new
	gawk '{ print "ipcon_5k", $$0; }' cached_ipcon_5k.txt >> data_cached.new

	mv data_cached.new data_cached.txt

bitdata_io.txt: data_cached.txt $(addprefix data_$(DEVICECLASS)_,$(addsuffix .txt,$(TESTS)))
	grep ^io $^ | tr -s ' ' | tr -d '\r' | cut -f2- -d' ' | sort -u > $@

bitdata_logic.txt: data_cached.txt $(addprefix data_$(DEVICECLASS)_,$(addsuffix .txt,$(TESTS)))
	grep ^logic $^ | tr -s ' ' | tr -d '\r' | cut -f2- -d' ' | sort -u > $@

bitdata_ramb$(RAM_SUFFIX).txt: data_cached.txt $(addprefix data_$(DEVICECLASS)_,$(addsuffix .txt,$(TESTS)))
	grep ^ramb$(RAM_SUFFIX) $^ | tr -s ' ' | tr -d '\r' | cut -f2- -d' ' | sort -u > $@

bitdata_ramt$(RAM_SUFFIX).txt: data_cached.txt $(addprefix data_$(DEVICECLASS)_,$(addsuffix .txt,$(TESTS)))
	grep ^ramt$(RAM_SUFFIX) $^ | tr -s ' ' | tr -d '\r' | cut -f2- -d' ' | sort -u > $@

bitdata_dsp0_5k.txt: data_cached.txt $(addprefix data_$(DEVICECLASS)_,$(addsuffix .txt,$(TESTS)))
	grep ^dsp0_5k $^ | tr -s ' ' | tr -d '\r' | cut -f2- -d' ' | sort -u > $@	

bitdata_dsp1_5k.txt: data_cached.txt $(addprefix data_$(DEVICECLASS)_,$(addsuffix .txt,$(TESTS)))
	grep ^dsp1_5k $^ | tr -s ' ' | tr -d '\r' | cut -f2- -d' ' | sort -u > $@	
		
bitdata_dsp2_5k.txt: data_cached.txt $(addprefix data_$(DEVICECLASS)_,$(addsuffix .txt,$(TESTS)))
	grep ^dsp2_5k $^ | tr -s ' ' | tr -d '\r' | cut -f2- -d' ' | sort -u > $@	
			
bitdata_dsp3_5k.txt: data_cached.txt $(addprefix data_$(DEVICECLASS)_,$(addsuffix .txt,$(TESTS)))
	grep ^dsp3_5k $^ | tr -s ' ' | tr -d '\r' | cut -f2- -d' ' | sort -u > $@	

bitdata_ipcon_5k.txt: data_cached.txt $(addprefix data_$(DEVICECLASS)_,$(addsuffix .txt,$(TESTS)))
	grep ^ipcon_5k $^ | tr -s ' ' | tr -d '\r' | cut -f2- -d' ' | sort -u > $@	

datafiles: $(addprefix data_,$(addsuffix .txt,$(TESTS)))

../icepack/icepack:
	$(MAKE) -C ../icepack

define data_template
data_$(DEVICECLASS)_$(1).txt: make_$(1).py ../icepack/icepack
	ICEDEVICE=$(DEVICECLASS) python3 make_$(1).py
	+ICEDEV=$(DEVICE) $(MAKE) -C work_$(DEVICECLASS)_$(1)
	ICEDEVICE=$(DEVICECLASS) python3 extract.py work_$(DEVICECLASS)_$(1)/*.glb > $$@
endef

$(foreach test,$(TESTS),$(eval $(call data_template,$(test))))

%.ok: %.bin
	bash check.sh $<

check: $(addsuffix .ok,$(basename $(wildcard work_$(DEVICECLASS)_binop/*.bin)))
check: $(addsuffix .ok,$(basename $(wildcard work_$(DEVICECLASS)_pin2pin/*.bin)))
check: $(addsuffix .ok,$(basename $(wildcard work_$(DEVICECLASS)_mesh/*.bin)))
check: $(addsuffix .ok,$(basename $(wildcard work_$(DEVICECLASS)_fanout/*.bin)))
check: $(addsuffix .ok,$(basename $(wildcard work_$(DEVICECLASS)_logic/*.bin)))
check: $(addsuffix .ok,$(basename $(wildcard work_$(DEVICECLASS)_cluster/*.bin)))
check: $(addsuffix .ok,$(basename $(wildcard work_$(DEVICECLASS)_iopack/*.bin)))
check: $(addsuffix .ok,$(basename $(wildcard work_$(DEVICECLASS)_pll/*.bin)))

clean:
	rm -rf work_$(DEVICECLASS)_*
	rm -rf data_*.txt
	rm -rf bitdata_*.txt
	rm -rf database_*.txt
	rm -rf timings_*.html

.PHONY: database datafiles check clean

=== iceprog/Makefile ===
--- 
+++ 
@@ -2,11 +2,9 @@
 
 ifneq ($(shell uname -s),Darwin)
   LDLIBS = -L/usr/local/lib -lm
-  CFLAGS = -MD -O0 -ggdb -Wall -std=c99 -I/usr/local/include
 else
   LIBFTDI_NAME = $(shell $(PKG_CONFIG) --exists libftdi1 && echo ftdi1 || echo ftdi)
   LDLIBS = -L/usr/local/lib -l$(LIBFTDI_NAME) -lm
-  CFLAGS = -MD -O0 -ggdb -Wall -std=c99 -I/usr/local/include
 endif
 
 ifeq ($(STATIC),1)
@@ -25,10 +23,10 @@
 
 install: all
 	mkdir -p $(DESTDIR)$(PREFIX)/bin
-	cp iceprog $(DESTDIR)$(PREFIX)/bin/iceprog
+	cp iceprog$(EXE) $(DESTDIR)$(PREFIX)/bin/iceprog$(EXE)
 
 uninstall:
-	rm -f $(DESTDIR)$(PREFIX)/bin/iceprog
+	rm -f $(DESTDIR)$(PREFIX)/bin/iceprog$(EXE)
 
 clean:
 	rm -f iceprog

=== icetime/Makefile ===
--- 
+++ 
@@ -26,10 +26,11 @@
 override LDFLAGS += --embed-file share
 endif
 
-icetime$(EXE): icetime.o
+icetime$(EXE): icetime.o iceutil.o
 	$(CXX) -o $@ $(LDFLAGS) $^ $(LDLIBS)
 
 icetime.o: icetime.cc timings.inc
+iceutil.o: iceutil.cc
 
 timings.inc: timings.py ../icefuzz/timings_*.txt
 	python3 timings.py > timings.inc.new

=== examples/iceblink/Makefile ===
--- 
+++ 
@@ -24,6 +24,6 @@
 	iCEburn.py  -e -v -w  $<
 
 clean:
-	rm -f $(PROJ).blif $(PROJ).asc $(PROJ).bin
+	rm -f $(PROJ).blif $(PROJ).asc $(PROJ).rpt $(PROJ).bin
 
 .PHONY: all prog clean

=== examples/icemulti/Makefile ===
prog: config.bin
	sudo iceprog config.bin

sudo-prog: config.bin
	@echo 'Executing prog as root!!!'
	sudo iceprog config.bin

config.bin: app0.bin app1.bin app2.bin app3.bin
	icemulti -v -A16 -p0 -o config.bin app0.bin app1.bin app2.bin app3.bin

app%.bin: app%.v icestick.pcf
	yosys -p "synth_ice40 -top top -blif $(basename $<).blif" $<
	arachne-pnr -o $(basename $<).asc -d 1k -P tq144 -p icestick.pcf $(basename $<).blif
	icetime -d hx1k -c 25 $(basename $<).asc
	icepack $(basename $<).asc $(basename $<).bin

clean:
	rm -f app?.asc app?.bin app?.blif config.bin

.PHONY: prog sudo-prog clean

=== examples/icestick/Makefile ===
--- 
+++ 
@@ -1,4 +1,7 @@
 PROJ = example
+# PROJ = rs232demo
+# PROJ = checker
+
 PIN_DEF = icestick.pcf
 DEVICE = hx1k
 
@@ -16,6 +19,21 @@
 %.rpt: %.asc
 	icetime -d $(DEVICE) -mtr $@ $<
 
+%_tb: %_tb.v %.v
+	iverilog -o $@ $^
+
+%_tb.vcd: %_tb
+	vvp -N $< +vcd=$@
+
+%_syn.v: %.blif
+	yosys -p 'read_blif -wideports $^; write_verilog $@'
+
+%_syntb: %_tb.v %_syn.v
+	iverilog -o $@ $^ `yosys-config --datdir/ice40/cells_sim.v`
+
+%_syntb.vcd: %_syntb
+	vvp -N $< +vcd=$@
+
 prog: $(PROJ).bin
 	iceprog $<

=== debian/changelog ===
fpga-icestorm (0~20181109git9671b76-1) unstable; urgency=medium

  * New upstream GIT HEAD
  * debian/patches: Refreshed patches

 -- Ruben Undheim <ruben.undheim@gmail.com>  Thu, 20 Dec 2018 11:09:19 +0100

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
                python3,
                txt2man,
                pkg-config
-Standards-Version: 4.2.0
+Standards-Version: 4.2.1
 Vcs-Browser: https://salsa.debian.org/electronics-team/fpga-icestorm
 Vcs-Git: https://salsa.debian.org/electronics-team/fpga-icestorm.git
 Homepage: http://www.clifford.at/icestorm/
